<!--买二送一 created By 1173944134@qq.com-->
<template>
    <!--横栏入口-->
    <div class="buy-21-banner fade-in" id="buyBanner">
        <img src="" class="desc"/>
        <div class="btn-con">
            <img src="" class="dtlBtn heart-beat"/>
        </div>
    </div>
    <!--规则弹窗-->
    <div class="yidialog-con buy-rule-con" id="buyRule">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body flex-row">
                <div class="btn-con heart-beat">
                    <img src="" class="ljgk-btn"/>
                </div>
                <div class="user-num">已有<span class="userNum">2000</span>人获得免单</div>
            </div>
            <div class="yid-cls-con">
                <img src="" class="yid-cls"/>
            </div>
        </div>
    </div>
    <!--确认弹窗-->
    <div class="yidialog-con buy-cfm-con" id="buyConfirm">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body flex-row">
                <div class="desc-one desc-first">
                    已有XXX位家长成功免单，
                </div>
                <div class="desc-one">
                    时不可失，失不再来哦！
                </div>
                <div class="btn-con flex-row">
                    <div class="btn-one fangq">
                        <img src="" class="fang-q"/>
                    </div>
                    <div class="btn-one qiangmd">
                        <img src="" class="qiang-md"/>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!--课程弹窗-->
    <div class="yidialog-con buy-course-con" id="buyCourse">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-cls-con">
                <img src="" class="yid-cls"/>
            </div>
            <div class="yid-con-body flex-row">
                <div class="djs-con flex-row">
                    有效期 48:59:59.9
                </div>
                <div class="course-con flex-row">
                    <div class="course-one flex-row">
                        <div class="left-con">
                            <img src="" class="badge"/>
                            <img src="" class="course-img"/>
                        </div>
                        <div class="right-con flex-row">
                            <div class="name"></div>
                            <div class="old-price">原价 ¥28.8</div>
                            <div class="ly-btn flex-row icon-click">0元抢</div>
                        </div>
                    </div>
                </div>
                <div class="ck-more">查看更多>></div>
                <div class="btm-back"></div>
            </div>
        </div>
    </div>
    <!--toast-->
    <div class="yidialog-con yid-toast-con" id="toastCon">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body flex-row">
                <!--消息-->
                <div class="msg"></div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        /**买二送一**/
        imgPath: resourcePath + '/imgs/groupPurchase/act/buy2send1/',
        courseCfmKey: 'buy_21_course_cfm',
        data: {
            /**买二送一用户状态：1=黑名单用户 2=已领取已使用 3=已领取未使用
             * 4=活动期间未购课（新用户） 5=购买1门课 6-已过期
             **/
            userStatus: 5,
            countDownTime: 0, // 倒计时
            courseList: [] // 课程
        },
        apiUrl: {
            pvuv: ApiHelper.SERVER + '/dengta/common/act/10015/addPvuv.json', // 实物pvuv微信使用接口
            getUserActStatus: ApiHelper.SERVER + '/dengta/common/act/10015/getUserActStatus.json'
        },
        pvuvKey: {},
        name: 'feed_back',
        addPvuv: function (data, callback) {
            ApiHelper.myLog('pvuv>>>>', data)
            $.get(this.apiUrl.pvuv, data)
            callback && setTimeout(callback, 100)
        },
        init: function () {
            ApiHelper.moreCourse && this.initMoreCourse()
        },
        // 课程主页
        initMoreCourse: function () {
            var that = this
            $.get(that.apiUrl.getUserActStatus, function (res) {
                var resValue = res.value || {}
                that.data = resValue || {}
                ApiHelper.idxInArr([3, 4, 5], resValue.userStatus) !== -1 && that._initMoreCourse()
                that.startTimeDown()
                ApiHelper.idxInArr([3, 4, 5], resValue.userStatus) !== -1 && that.checkToast()
            })
        },
        // 是否toast
        checkToast: function () {
            var that = this
            var source = ApiHelper.getQueryString('source')
            if (source !== 'msg') {
                return
            }
            var userStatus = this.data.userStatus
            if (userStatus === 3) {
                that.showCourseDia()
                return
            }
            $(toastCon).appendTo($('body'))
            if (userStatus === 2) {
                $('#toastCon .msg').text('您的免单券已经使用了哦，去商城看看其他课程')
            } else if (userStatus === 6) {
                $('#toastCon .msg').text('您的免单券已过期，去商城看看其他课程')
            }
            $('#toastCon').css({
                display: 'flex'
            })
            setTimeout(function () {
                $('#toastCon').hide()
            }, 3000)
        },
        hasBuyOne: function () {
            var that = this
            var buyOneCourse = that.data.userStatus === 5
            return buyOneCourse
        },
        // 有一张免单券未使用
        hasOneFree: function () {
            var that = this
            return that.data.userStatus === 3
        },
        // 倒计时
        startTimeDown: function () {
            new NewTimer(this.data.countDownTime, function (changeArr) {
                $('#buyCourse .djs-con').text('有效期 ' + changeArr[1] + ':' + changeArr[2] + ':' + changeArr[3] + '.' + changeArr[4])
            }, function () {
                $('#buyCourse .kj-djs').text('有效期 0:0:0.0')
            }, 10).startCountDown()
        },
        _initMoreCourse: function () {
            var that = this
            $(buyBanner).insertBefore($('.fix-top .course_tab'))
            $('#course_box').css({
                paddingTop: '2.64rem'
            })
            $('.fix-top').css({
                zIndex: 9
            })
            $('#buyBanner').css({
                backgroundImage: 'url("' + that.imgPath + 'back_dft.png?v=' + window.groupBuyVersion + '")'
            })
            var descImg = that.hasOneFree() ? 'have_one.png' : 'buy2_1.png'
            var dftBtnImg = that.hasOneFree() ? 'go_use.png' : 'detail_btn.png'
            that.hasOneFree() && $('#buyBanner .desc').addClass('desc-has')
            $('#buyBanner .desc').attr('src', that.imgPath + descImg + '?v=' + window.groupBuyVersion)
            $('#buyBanner .dtlBtn').attr('src', that.imgPath + dftBtnImg + '?v=' + window.groupBuyVersion)
            // 点击banner
            $('#buyBanner').click(function () {
                (that.data.userStatus === 5 || that.data.userStatus === 4) && that.showBuyRule()
                that.data.userStatus === 3 && that.showCourseDia()
                that.addPvuv({
                    pvuvKeyId: 256
                })
            })
        },
        // 课程弹窗
        showCourseDia: function () {
            var that = this
            that.addPvuv({
                pvuvKeyId: 259
            })
            if ($('#buyCourse').length === 0) {
                $(buyCourse).appendTo($('body'))
                $('#buyCourse .yid-con-body').css({
                    backgroundImage: 'url("' + that.imgPath + 'course_back.png?v=' + window.groupBuyVersion + '")'
                })
                $('#buyCourse .yid-cls-con').click(function () {
                    var cfm = localStorage.getItem(that.courseCfmKey)
                    if (!cfm) {
                        that.showConfirmDia()
                        localStorage.setItem(that.courseCfmKey, 1)
                        return
                    }
                    $('#buyCourse').css({
                        display: 'none'
                    })
                })
                $('#buyCourse .ck-more').click(function () {
                    $('#buyCourse').css({
                        display: 'none'
                    })
                })
                that.addCourses()
                $('#buyCourse .yid-cls').attr('src', that.imgPath + 'close_bs.png?v=' + window.groupBuyVersion)
            }
            $('#buyCourse').css({
                display: 'flex'
            })
        },
        // 添加课程
        addCourses: function () {
            var that = this
            var courseSize = that.data.courseList.length
            courseSize = courseSize > 4 ? 4 : courseSize
            for (var i = 0; i < courseSize; i++) {
                var one = that.data.courseList[i]
                if (!one) {
                    continue
                }
                var courseOne = $('.course-one:first').clone()
                courseOne.appendTo($('#buyCourse .course-con'))
                courseOne.find('.name').text(one.courseName)
                courseOne.find('.badge').attr('src', that.imgPath + 'xs_free.png?v=' + window.groupBuyVersion)
                courseOne.find('.course-img').attr('src', resourcePath + '/imgs/groupPurchase/newCourseImg/' + one.introImageUrl + '?v=' + window.groupBuyVersion)
                courseOne.find('.old-price').text('原价 ￥' + ApiHelper.floorPrice(one.originBuyPrice / 100))
                courseOne.css({
                    display: 'flex'
                })
                courseOne.data('courseId', one.courseId)
                courseOne.data('channel', one.channel || '')
                courseOne.click(function () {
                    location.href = '/wx/groupBuy/courseDetails.html?posterOpenId=natureSubPoster&courseId=' + $(this).data('courseId') +
                        '&state=' + $(this).data('channel')
                })
            }
            if (courseSize < 4) {
                $('#buyCourse .btm-back').css({
                    backgroundImage: 'url("' + that.imgPath + 'course_back_btm.png?v=' + window.groupBuyVersion + '")'
                })
                $('#buyCourse .btm-back').show()
            }
            if (courseSize === 0) {
                $('#buyCourse .djs-con').css({
                    opacity: 0
                })
                $('#buyCourse .course-con,#buyCourse .ck-more').hide()
            }
        },
        // 虚拟家长数字
        getUserCount: function () {
            return this.data.userNum || 2001
        },
        // 确认弹窗
        showConfirmDia: function () {
            var that = this
            var buyCount = that.data.buyNum || that.getUserCount()
            $(buyConfirm).appendTo($('body'))
            $('#buyConfirm').css({
                display: 'flex'
            })
            $('#buyConfirm .desc-first').text('已有' + buyCount + '位家长成功免单，')
            $('#buyConfirm .yid-con-body').css({
                backgroundImage: 'url("' + that.imgPath + 'confirm_back.png?v=' + window.groupBuyVersion + '")'
            })
            $('#buyConfirm .fangq').click(function () {
                $('#buyConfirm').css({
                    display: 'none'
                })
                $('#buyCourse').css({
                    display: 'none'
                })
            })
            $('#buyConfirm .qiangmd').click(function () {
                $('#buyConfirm').css({
                    display: 'none'
                })
            })
            $('#buyConfirm .fang-q').attr('src', that.imgPath + 'fangqi.png?v=' + window.groupBuyVersion)
            $('#buyConfirm .qiang-md').attr('src', that.imgPath + 'i_qiang_btn.png?v=' + window.groupBuyVersion)
        },
        // 规则弹窗
        showBuyRule: function () {
            var that = this
            var buyOneCourse = that.hasBuyOne()
            var backImg = buyOneCourse ? 'guide.png' : 'rule.png'
            var btnImg = buyOneCourse ? 'i_qiang.png' : 'qiang_btn.png'
            if ($('#buyRule').length === 0) {
                $(buyRule).appendTo($('body'))
                buyOneCourse && $('#buyRule').addClass('buy-guide-con')
                $('#buyRule .yid-cls').attr('src', that.imgPath + 'close_bs.png?v=' + window.groupBuyVersion)
                $('#buyRule .yid-con-body').css({
                    backgroundImage: 'url("' + that.imgPath + backImg + '?v=' + window.groupBuyVersion + '")'
                })
                $('#buyRule .userNum').text(that.getUserCount())
                buyOneCourse && $('#buyRule .user-num').show()
                $('#buyRule .ljgk-btn').attr('src', that.imgPath + btnImg + '?v=' + window.groupBuyVersion)
                $('#buyRule .btn-con').click(function () {
                    that.addPvuv({
                        pvuvKeyId: buyOneCourse ? 258 : 257
                    })
                    $('#buyRule').hide()
                })
                $('#buyRule .yid-cls-con').click(function () {
                    $('#buyRule').hide()
                })
            }
            $('#buyRule').css({
                display: 'flex'
            })
        }
    }
</script>

<style scoped lang="less">
    .flex-row {
        display: -moz-box;
        /* 老版本语法: Firefox (buggy) */
        display: -ms-flexbox;
        /* 混合版本语法: IE 10 */
        display: -webkit-flex;
        /* 新版本语法: Chrome 21+ */
        display: flex;
    }

    @cl-mask: rgba(0, 0, 0, 0.9);
    /**弹窗**/
    .yidialog-con {
        position: fixed;
        width: 100%;
        height: 100%;
        top: 0px;
        left: 0px;
        align-items: center;
        justify-content: center;
        z-index: 1000;

        .yid-back {
            position: absolute;
            left: 0px;
            top: 0px;
            width: 100%;
            height: 100%;
            text-align: center;
            background: @cl-mask;
        }

        .yid-con {
            position: relative;
            display: flex;
            justify-content: center;
            align-content: center;
            color: #ffffff;
            flex-wrap: wrap;

            .yid-cls {
                position: relative;
                z-index: 9999;
                width: 0.51rem;
                height: 0.51rem;
                flex-shrink: 0;
            }

            .yid-hand {
                position: absolute;
                width: 1rem;
                top: 3.1rem;
                right: 0.1rem;
                animation: handClick 1s infinite;
            }
        }

        .yid-con-col {
            flex-direction: column;
        }
    }

    /**横栏入口**/
    .buy-21-banner {
        height: 129px;
        background-size: 100% 100%;
        background-repeat: no-repeat;
        position: relative;
        display: flex;
        justify-content: center;
        background-color: #ffffff;

        .desc {
            width: 308px;
            height: 52px;
            margin-top: 20px;
            margin-left: 84px;
        }

        .desc-has {
            width: 362px;
            height: 44px;
            margin-top: 18px;
            margin-left: 82px;
        }

        .dtlBtn {
            position: absolute;
            width: 110px;
            height: 110px;
            top: 6px;
            right: 42px;
        }
    }

    /**规则弹窗**/
    .buy-rule-con {
        display: none;

        .yid-con {
            flex-direction: column;

            .yid-con-body {
                background-size: 100% 100%;
                background-repeat: no-repeat;
                position: relative;
                justify-content: center;
                width: 660px;
                height: 818px;

                .btn-con {
                    width: 365px;
                    height: 72px;
                    position: absolute;
                    bottom: 38px;
                    left: 147px;

                    .ljgk-btn {
                        width: 100%;
                        height: 100%;
                    }
                }

                .user-num {
                    font-size: 24px;
                    margin-top: 800px;
                    color: #000000;
                    display: none;
                }
            }

            .yid-cls-con {
                margin-top: 30px;
                align-self: center;
            }
        }
    }

    /**引导弹窗**/
    .buy-guide-con {
        .yid-con {
            .yid-con-body {
                width: 691px;
                height: 850px;

                .btn-con {
                    width: 466px;
                    height: 91px;
                    bottom: 60px;
                    left: 112px;
                }
            }
        }
    }

    /**确认弹窗**/
    .buy-cfm-con {
        .yid-con {

            .yid-con-body {
                width: 622px;
                height: 466px;
                background-size: 100% 100%;
                background-repeat: no-repeat;
                position: relative;
                flex-direction: column;

                .desc-one {
                    font-size: 36px;
                    line-height: 62px;
                    color: #c43300;
                    font-weight: bold;
                    text-align: center;
                }

                .desc-first {
                    margin-top: 169px;
                }

                .btn-con {
                    justify-content: center;
                    margin-top: 52px;

                    .fang-q {
                        width: 170px;
                        height: 80px;
                        background-image: linear-gradient(0deg, #b4b4b4 0%, #c2c2c2 100%);
                        border-radius: 40px;
                    }

                    .qiang-md {
                        width: 330px;
                        height: 80px;
                        margin-left: 34px;
                        background-image: linear-gradient(0deg, #ff422f 0%, #ff7256 100%);
                        border-radius: 40px;
                    }
                }
            }
        }
    }

    /**课程弹窗**/
    .buy-course-con {
        .yid-con {
            flex-direction: column;

            .yid-cls-con {
                width: 47px;
                height: 47px;
            }

            .yid-con-body {
                background-size: 100% auto;
                background-position: center top;
                background-repeat: no-repeat;
                margin-top: -21px;
                width: 661px;
                max-height: 976px;
                padding-bottom: 27px;
                flex-direction: column;
                align-items: center;
                background-image: linear-gradient(0deg, #ff8080 1%, #ff8585 100%);
                border-radius: 60px;
                position: relative;

                .djs-con {
                    width: 356px;
                    height: 49px;
                    background-color: #ff971c;
                    border-radius: 22px;
                    justify-content: center;
                    align-items: center;
                    margin-top: 243px;
                    font-size: 36px;
                    font-weight: bold;
                }

                .course-con {
                    width: 577px;
                    max-height: 611px;
                    overflow-y: auto;
                    background-color: #ffffff;
                    border-radius: 30px;
                    margin-top: 13px;
                    flex-direction: column;
                    align-items: center;
                    padding-bottom: 20px;

                    .course-one {
                        width: 541px;
                        height: 136px;
                        margin-top: 15px;
                        background-color: #fefefe;
                        box-shadow: 0px 0px 4px 0px #c6c6c6;
                        border-radius: 12px;
                        display: none;

                        .left-con {
                            width: 185px;
                            height: 124px;
                            background-color: #ffffff;
                            border-radius: 6px;
                            margin-top: 5px;
                            margin-left: 25px;
                            position: relative;

                            .badge {
                                width: 80px;
                                height: 31px;
                                position: absolute;
                                top: 0;
                                left: 0;
                            }
                        }

                        .right-con {
                            flex-direction: column;
                            margin-left: 28px;
                            flex-grow: 1;

                            .name {
                                font-size: 26px;
                                color: #303030;
                                margin-top: 14px;
                                font-weight: bold;
                            }

                            .old-price {
                                text-decoration: line-through;
                                font-size: 24px;
                                color: #ff3e53;
                                margin-top: 16px;
                            }

                            .ly-btn {
                                width: 145px;
                                height: 52px;
                                background-image: linear-gradient(90deg, #ff3b55 0%, #ff6c40 100%);
                                border-radius: 18px;
                                border: solid 1px #ff243d;
                                font-size: 35px;
                                color: #ffffff;
                                justify-content: center;
                                align-items: center;
                                align-self: flex-end;
                                margin-right: 17px;
                                margin-top: -4px;
                            }
                        }
                    }
                }

                .ck-more {
                    margin-top: 12px;
                    font-size: 30px;
                    font-weight: bold;
                    color: #ff4a4a;
                }

                .btm-back {
                    display: none;
                    position: absolute;
                    bottom: -2px;
                    left: 0;
                    height: 94px;
                    width: 100%;
                    background-size: 100% 100%;
                    background-position: center bottom;
                    background-repeat: no-repeat;
                }
            }
        }
    }

    /**toast**/
    .yid-toast-con {
        display: none;

        .yid-back {
            opacity: 0;
        }

        .yid-con {
            .yid-con-body {
                justify-content: center;
                align-items: center;

                .msg {
                    padding: 20px;
                    background-color: #333333;
                    color: #ffffff;
                    font-size: 28px;
                    border-radius: 10px;
                }
            }
        }
    }

    /**动画**/
    .icon-click {
        animation: iconClick 1s infinite;
    }

    @keyframes iconClick {
        0%, 100% {
            margin-bottotm: 0;
        }
        50% {
            margin-bottom: -35px;
            transform: scale(1.1);
        }
    }

    @keyframes handClick {
        from {
            margin-top: 0rem;
            margin-right: 0rem;
        }
        50% {
            margin-top: -0.1rem;
            margin-right: 0.1rem;
            transform: scale(0.9);
        }
        to {
            margin-top: -0rem;
            margin-right: 0rem;
        }
    }

    .scale-size {
        animation: scaleSize 2s infinite;
    }

    @keyframes scaleSize {
        from {
            transform: scale(0.9);
            opacity: 0.9;
        }
        50% {
            transform: scale(1.2);
            opacity: 1;
        }
        to {
            transform: scale(0.9);
            opacity: 0.9;
        }
    }

    .heart-beat {
        animation: heartBeat 1s infinite;
    }

    @keyframes heartBeat {
        0% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        14% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        28% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        42% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        70% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }
    }

    /**淡入*/
    .fade-in {
        animation: fadeIn 1s;
    }

    @keyframes fadeIn {
        from {
            opacity: 0;
        }
        to {
            opacity: 1;
        }
    }

    /**从上向下淡入*/
    .slide-down {
        animation: slideDown .5s;
    }

    @keyframes slideDown {
        from {
            -webkit-transform: translate3d(0, -100%, 0);
            transform: translate3d(0, -100%, 0);
            visibility: visible;
            opacity: 0;
        }
        to {
            -webkit-transform: translate3d(0, 0, 0);
            transform: translate3d(0, 0, 0);
            opacity: 1;
        }
    }

    /**从上向下淡出*/
    .slide-down-out {
        animation: slideDownOut 1s;
    }

    @keyframes slideDownOut {
        from {
            -webkit-transform: translate3d(0, 0, 0);
            transform: translate3d(0, 0, 0);
            visibility: visible;
            opacity: 1;
        }
        to {
            -webkit-transform: translate3d(0, 100%, 0);
            transform: translate3d(0, 100%, 0);
            opacity: 0;
        }
    }
</style>
